/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include "task.hpp"

namespace nostalgia::studio {

void TaskRunner::update(core::Context *ctx) noexcept {
	for (auto i = 0u; i < m_tasks.size(); ++i) {
		if (m_tasks[i]->update(ctx) == studio::TaskState::Done) {
			oxIgnoreError(m_tasks.erase(i--));
		}
	}
}

void TaskRunner::add(Task *task) noexcept {
	m_tasks.emplace_back(task);
}

}